import hell2;
import token;
import player;

/**
 * パーティクル
 */
class Particle : Token
{
public:
	/**
	 * 親
	 */
	static TokenManager!(Particle) parent;
	int id;
	int timer;
	char[] msg;
public:
	void create(int id, float x, float y, float w, float h, float deg=0, float speed=0)
	{
		this.id = id;
		switch(id)
		{
		case 0:
		case 2:
		case 5:
			timer = 80+Hell_rand(40);
			break;
		case 1:
		case 3:
		case 6:
			timer = 60;
			break;
		case 4:
			timer = 8;
			break;
		case 7:
			timer = 16;
			break;
		case 8:
			timer = 32;
			break;
		}
		super.create(x, y, w, h, deg, speed);
	}

	static void add(int id, float x, float y, float w, float h, float deg=0, float speed=0, char[] msg=null)
	{
		Particle particle = parent.getToken();
		if(!particle) return;
		particle.create(id, x, y, w, h, deg, speed);
		particle.msg = msg;
	}
	static void addDestroy(float x, float y, float size)
	{
		for(int i = 0; i < 16; i++)
		{
			add(0, x, y, size, size, Hell_rand(360), 10+10*Hell_rand(3));
		}
	}
	static void addItem(float x, float y)
	{
		add(1, x, y, 0, 0, 90, 1);
	}
	static void addRecovery(float x, float y)
	{
		add(3, x, y, 0, 0, 90, 1);
	}
	static void addDamage(float x, float y, int cnt)
	{
		for(int i = 0; i < cnt; i++)
		{
			add(2, x, y, 4, 4, Hell_rand(360), 1+Hell_rand(3));
		}
	}
	static void addMessage(float x, float y, char[] msg)
	{
		add(6, x, y, 0, 0, 90, 1, msg);
	}
	static void addBullet(float x, float y, float deg, float speed)
	{
		add(8, x, y, 0, 0, deg, speed);
	}
	void update()
	{
		switch(id)
		{
		case 0:
		case 2:
		case 5:
			timer--;
			if(timer < 1) exist = false;
			vx *= 0.97;
			vy *= 0.97;
			break;
		case 8:
			vx *= 0.97;
			vy *= 0.97;
			timer--;
			if(timer < 1) exist = false;
			break;
		default:
			timer--;
			if(timer < 1) exist = false;
			break;
		}
		super.move();
	}
	void draw()
	{
		Hell_setAlpha(HELL_ALPHA_ADD);
		switch(id)
		{
		case 7:
			if(timer/4 < 1) { break; }
			float s = timer/4/128.0f;
			Hell_drawTextureEx("all", x, y, 768, 0, 128, 128, s, s, 0, 0, 0, 0xff, 0xff);
			break;
		case 0:
			if(timer < 30 && timer%4 != 0) { break; }
			float s = 4*w/128.0f;
			Hell_drawTextureEx("all", x, y, 768, 0, 128, 128, s, s, 0, Hell_rand(0xff), 0xff, Hell_rand(0xff), 0xff);
			break;
		case 2:
			if(timer < 30 && timer%4 != 0) { break; }
			float s = 4*w/128.0f;
			Hell_drawTextureEx("all", x, y, 768, 0, 128, 128, s, s, 0, Hell_rand(0xff), Hell_rand(0xff), 0xff, 0xff);
			break;
		case 5:
			if(timer < 30 && timer%4 != 0) { break; }
			float s = 4*w/128.0f;
			Hell_drawTextureEx("all", x, y, 768, 0, 128, 128, s, s, 0, 0xff, Hell_rand(0xff), Hell_rand(0xff), 0xff);
			break;
		case 1:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			int alpha = timer > 30 ? 255 : 255*timer/30;
			Hell_drawFont("POWER UP!", x, y, .5f, 0xff, 0xff, 0xff, alpha);
			break;
		case 3:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			int alpha = timer > 30 ? 255 : 255*timer/30;
			Hell_drawFont("RECOVERY!", x, y, .5f, 0xff, 0xff, 0xff, alpha);
			break;
		case 4:
			int d = Hell_randInt(-4, 4);
			Hell_drawCircle(x, y, w+d, 0, Hell_rand(0x7f), Hell_rand(0x7f), 0xff, 0xff);
			break;
		case 6:
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			int alpha = timer > 30 ? 255 : 255*timer/30;
			Hell_drawFont(msg, x, y, .5f, 0xff, 0xff, 0xff, alpha);
			break;
		case 8:
			int r = (timer)/4 + 1;
			int a = 0xff*timer/32;
			float s = 4*r/128.0f;
			Hell_drawTextureEx("all", x, y, 768, 0, 128, 128, s, s, 0, 0xff, 0, 0, 0xff);
			break;
		}
		Hell_setAlpha(HELL_ALPHA_NORMAL);
	}
}
