import hell2;
import token;
import particle;
import enemy;

/**
 * 自機クラス
 */
class Player : Token
{
public:
	const int SIZE = 32;
	int  timer;
	int  width;
	bool bLock;
	int  tLock;
	bool bStop;
public:
	/**
	 * コンストラクタ
	 */
	this()
	{
	}
	/**
	 * 生成
	 */
	void create(float x, float y, float w, float h)
	{
		timer = 0;
		exist = true;
		width = SIZE;
		bLock = false;
		super.create(x, y, width, width, 0, 0, 0, 0);
		tLock = 0;
		bStop = false;
	}
	
	/**
	 * アイテム取得
	 */
	void getItem(Item item)
	{
	}
	
	bool isShotStart()
	{
		return Shot.parent.count() == 0;
	}
	void stop()
	{
		bStop = true;
	}
	void start()
	{
		bStop = false;
	}
	/**
	 * 更新
	 */
	void update()
	{
		if(bStop) { return; }
		
		bool lock = false;
		foreach(e; Enemy.parent.getArray())
		{
			if(!e.exist)        { continue; }
			if(!e.isHit2(this)) { continue; }
			if(!bLock) { Hell_playWAV("pipi", 0, 3); }
			lock = true;
			tLock++;
			if(tLock%2 == 0)
			{
				width++;
				if(width > 80) { width = 80; }
			}
			break;
		}
		bLock = lock;
		
		if(isShotStart())
		{
			timer++;
		}
		x = Hell_getMouseX();
		y = Hell_getMouseY();
		Shot.setWidth(width);
		if(isShotStart() && Hell_isPushEnter())
		{
			Hell_playWAV("shot", 0, 1);
			Shot.add(0, x, y, 0, 0);
			width = 6;
			tLock = 0;
		}
		w = width;
	}
	
	/**
	 * 描画
	 */
	void draw()
	{
		int rWidth = isShotStart() ? 0 : 1;
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTextureEx("view", x, y);
		int r = cast(int)w;
		Hell_setAlpha(HELL_ALPHA_ADD);
		for(int i = 0; i < 8; i++)
		{
			int t = timer*2 + i * 360 / 8;
			float px = x + r * Hell_cosEx(t);
			float py = y - r * Hell_sinEx(t);
			Hell_drawRectEx(px, py, 4, 4, rWidth, 0, 0xff, bLock ? 0 : 0xff, 0x00);
		}
	}
}

/**
 * 自機ショットクラス
 */
class Shot : Token
{
public:
	/**
	 * 親
	 */
	static TokenManager!(Shot) parent;
	int id;     // ID
	int timer;
	bool bLock;
	static int width;
public:
	/**
	 * 生成
	 */
	void create(int id, float x, float y, float deg, float speed)
	{
		this.id = id;
		super.create(x, y, width, width, deg, speed, ax, ay);
		timer = 60;
		bLock = false;
	}
	/**
	 * 生成（外からの入り口）
	 */
	static void add(int id, float x, float y, float deg, float speed)
	{
		Shot shot = parent.getToken();
		if(!shot) return;
		shot.create(id, x, y, deg, speed);
	}
	
	static void setWidth(int width)
	{
		this.width = width;
	}
	
	bool isHitStart()
	{
		return timer < 3;
	}
	
	/**
	 * 更新
	 */
	void update()
	{
		bLock = false;
		timer--;
		if(timer < 1)
		{
			exist = false;
		}
	}
	
	/**
	 * 描画
	 */
	void draw()
	{
		float r = w + timer*2;
		Hell_setAlpha(HELL_ALPHA_ADD);
		for(int i = 0; i < 16; i++)
		{
			int t = timer*4 + i * 360 / 16;
			float px = x + r * Hell_cosEx(t);
			float py = y - r * Hell_sinEx(t);
			Hell_drawRectEx(px, py, 4, 4, 0, 0, 0xff, bLock ? 0x00 : 0xff, 0x00);
		}
		if(timer%24 < 16)
		{
			Hell_drawCircle(x, y, w, 0, 0xff, bLock ? 0x00 : 0xff, 0);
		}
	}
	
	// 消滅
	void vanish()
	{
		exist = false;
	}
}

/**
 * アイテムトークン
 */
class Item : Token
{
public:
	/**
	 * 親
	 */
	static TokenManager!(Item) parent;
	int id;     // ID
	int timer;
public:
	/**
	 * 生成
	 */
	void create(int id, float x, float y, float w, float h, float deg, float speed, float ax=0, float ay=0)
	{
		this.id = id;
		super.create(x, y, w, h, deg, speed, ax, ay);
		timer = 0;
	}
	/**
	 * 生成（外から呼ばれる）
	 */
	static void add(float x, float y, float deg, float speed, float ax=0, float ay=0)
	{
		Item item = parent.getToken();
		if(!item) return;
		item.create(0, x, y, 48, 48, deg, speed, ax, ay);
	}
	/**
	 * 更新
	 */
	void update()
	{
		timer++;
		super.move();
		if(isOutOfWindow())
		{
			exist = false;
		}
	}
	/**
	 * 描画
	 */
	void draw()
	{
	}
}
